###################################################################################################################################################
# Copyright 2016 Orchid Systems 
# -----------------------------
# Permitted for use with Orchid Systems Modules only.
# The code is supplied on an as is basis for training and demonstration purposes only and is not supported by Orchid Systems.
# If this code is deployed in a live production environment it is the responsibility of the End User to ensure 
# that it is operating as required.
###################################################################################################################################################


#################### Import Modules ###########################################
from accpac import *

import time
import datetime

#################### Global Variables #########################################

vARAGE = None
vARCUS = None
vAGEOPT = None

default_email = "Susan.Prommer@SampleCompany.LTD"
###############################################################################


def RunCustomerAging():
	rvspyTrace("RunCustomerAging")
	
	global vARAGE
	global vARCUS
	global vAGEOPT

	if vARCUS == None:
		vARCUS = openView("AR0024", 1)	# Customer

	if vARAGE == None:
		vARAGE = openView("AR0055", 1)	# A/R Aging superview
	
	if vAGEOPT == None:
		vAGEOPT = openView("AR0004", 1)	# A/R Statement options

	# Get statement options.
	vAGEOPT.recordClear()
	vAGEOPT.browse()
	vAGEOPT.fetch()

	# check each Active customer:
	vARCUS.recordClear()
	vARCUS.browse("SWACTV = 1", 1)
	while vARCUS.fetch() == 0:
		# while fetch is successful, run aging on it.
		vARAGE.recordClear()
		vARAGE.put("CMNDCODE", 61, False) # Single Age Calculation
		vARAGE.put("AGEINVDTSW", 1, False) # Document Date
		vARAGE.put("CUSTID", vARCUS.get("IDCUST").strip(), False)
		vARAGE.put("RUNDATE", sessionDate(), False)
		vARAGE.put("CUTOFFDATE", "20991231", False)
		vARAGE.put("SWPREPAYMT", 1, False) # Include Prepayments
		vARAGE.put("AGEPERIOD2", vAGEOPT.get("AGINPERD1"), False) # first period
		vARAGE.put("AGEPERIOD3", vAGEOPT.get("AGINPERD2"), False) # second period
		vARAGE.put("AGEPERIOD4", vAGEOPT.get("AGINPERD3"), False) # third period
		vARAGE.process()

		# Check balance:
		curr_bal = vARAGE.get("AMTDUE1TC")
		pd1_bal = vARAGE.get("AMTDUE2TC")
		pd2_bal = vARAGE.get("AMTDUE3TC")
		pd3_bal = vARAGE.get("AMTDUE4TC")
		
		# Outstanding balance:
		outbal = vARAGE.get("AMTDUE1TC") + vARAGE.get("AMTDUE2TC") + vARAGE.get("AMTDUE3TC") + vARAGE.get("AMTDUE4TC")
		outbal = outbal + vARAGE.get("AMTDUE5TC") + vARAGE.get("AMTDUE6TC")  + vARAGE.get("AMTDUE7TC") + vARAGE.get("AMTDUE8TC") + vARAGE.get("AMTDUE9TC") 

		
		# Credit limit:
		credLimit = vARCUS.get("AMTCRLIMT")
		
		notify = False
		
		if (outbal > credLimit):
			notify = True
		if (pd1_bal > 0) or (pd2_bal > 0) or (pd3_bal > 0):
			notify = True
		
		# email a list to a default address.
		if notify == True:
			sendEmailNotification()
			
	vARAGE.close()
	vARCUS.close()
	
	vARAGE = None
	vARCUS = None
			

########### sendEmailNotification ######
def sendEmailNotification():
	rvspyTrace("sendEmailNotification")

	sendemail = 0
	global vARAGE
	global vARCUS

	m = emailStart()
	emailTo(m, default_email)

	idcust = vARCUS.get("IDCUST")

	# Subject:
	subj = "Customer [" + idcust.strip() + "] has outstanding balance"
	emailSubject(m, subj)

	# You can set a text email body with emailBody, or a HTML body with emailHtml
	# emailBody(m, "An order was created.")

	temp =  "<a href=\"orchid:" + org.strip() + "/AR1700/Customer No.=" + idcust.strip() + "\"> Click here to open the associated Customer Inquiry!</a>"

	html = """<html><body> {SUBJ} <br><br> The customer {CUSTOMER} has overdue balance<br><br>
	outstanding balance: {outbal}<br><br>""" + temp + """<br><br>
	credit limit: {credit}<br><br>
	{BalanceTable}<br>
	</body></html>"""

	# Add the details
	html = html.replace("{SUBJ}", subj)

	# replace customer:
	html = html.replace("{CUSTOMER}", idcust.strip())
	
	# replace outstanding balance.
	outbal = vARAGE.get("AMTDUE1TC") + vARAGE.get("AMTDUE2TC") + vARAGE.get("AMTDUE3TC") + vARAGE.get("AMTDUE4TC")
	outbal = outbal + vARAGE.get("AMTDUE5TC") + vARAGE.get("AMTDUE6TC")  + vARAGE.get("AMTDUE7TC") + vARAGE.get("AMTDUE8TC") + vARAGE.get("AMTDUE9TC") 

	html = html.replace("{outbal}", "{:,.2f}".format(outbal))

	# replace credit limit.
	credLimit = vARCUS.get("AMTCRLIMT")
	html = html.replace("{credit}", "{:,.2f}".format(credLimit))

	curr_bal = vARAGE.get("AMTDUE1TC") + vARAGE.get("TOTFWDTC")
	pd1_bal = vARAGE.get("AMTDUE2TC")
	pd2_bal = vARAGE.get("AMTDUE3TC")
	pd3_bal = vARAGE.get("AMTDUE4TC")
	pd4_bal = vARAGE.get("AMTDUE5TC") # + vARAGE.get("AMTDUE6TC")  + vARAGE.get("AMTDUE7TC") + vARAGE.get("AMTDUE8TC") + vARAGE.get("AMTDUE9TC")
	
	html_tbl = ""
	
	if (pd1_bal > 0) or (pd2_bal > 0) or (pd3_bal > 0):
		# build table.
		html_tbl = "<table>"
		
		# add header row.
		html_tbl = html_tbl + "<tr><th style='width:150px; text-align: right'>Period</th><th style='width:150px; text-align: right'>Balance</th></tr>"
		
		# add row.
		if (curr_bal > 0):
			tbl_row = "<tr><td style='width:150px; text-align: right'>{period}</td><td style='width:150px; text-align: right'>{bal}</td></tr>"
			tbl_row = tbl_row.replace("{bal}", "{:,.2f}".format(curr_bal))
			tbl_row = tbl_row.replace("{period}", "Current")
			html_tbl = html_tbl + tbl_row

		if (pd1_bal > 0):
			tbl_row = "<tr><td style='width:150px; text-align: right'>{period}</td><td style='width:150px; text-align: right'>{bal}</td></tr>"
			tbl_row = tbl_row.replace("{bal}", "{:,.2f}".format(pd1_bal))
			tbl_row = tbl_row.replace("{period}", "From 1 to " + "{:.0f}".format(vARAGE.get("AGEPERIOD2")))
			html_tbl = html_tbl + tbl_row
			
		if (pd2_bal > 0):
			tbl_row = "<tr><td style='width:150px; text-align: right'>{period}</td><td style='width:150px; text-align: right'>{bal}</td></tr>"
			tbl_row = tbl_row.replace("{bal}", "{:,.2f}".format(pd2_bal))
			tbl_row = tbl_row.replace("{period}", "From " + "{:.0f}".format(vARAGE.get("AGEPERIOD2") + 1) + " to " + "{:.0f}".format(vARAGE.get("AGEPERIOD3")))
			html_tbl = html_tbl + tbl_row

		if (pd3_bal > 0):
			tbl_row = "<tr><td style='width:150px; text-align: right'>{period}</td><td style='width:150px; text-align: right'>{bal}</td></tr>"
			tbl_row = tbl_row.replace("{bal}", "{:,.2f}".format(pd3_bal))
			tbl_row = tbl_row.replace("{period}", "From " + "{:.0f}".format(vARAGE.get("AGEPERIOD3") + 1) + " to " + "{:.0f}".format(vARAGE.get("AGEPERIOD4")))
			html_tbl = html_tbl + tbl_row

		if (pd4_bal > 0):
			tbl_row = "<tr><td style='width:150px; text-align: right'>{period}</td><td style='width:150px; text-align: right'>{bal}</td></tr>"
			tbl_row = tbl_row.replace("{bal}", "{:,.2f}".format(pd4_bal))
			tbl_row = tbl_row.replace("{period}", "Over " + "{:.0f}".format(vARAGE.get("AGEPERIOD4")))
			html_tbl = html_tbl + tbl_row

			
		html_tbl = html_tbl + "</table>"
		
	html = html.replace("{BalanceTable}", html_tbl)
		
	emailHtml(m, html)
	emailSend(m)

############################################# MAIN ###################################################

def main(args):
	RunCustomerAging()
	#log("OK|0|This is the log message '" + args + "'")

	